CacheServerMXBean (Apache Geode 2.0.2)
Description: declaration: package: org.apache.geode.management, interface: CacheServerMXBean

Package org.apache.geode.management

# Interface CacheServerMXBean

public interface CacheServerMXBean
MBean that provides access to information and management functionality for a `CacheServer`.

The will be one CacheServerMBean per `CacheServer` started in GemFire node.

ObjectName for this MBean is GemFire:service=CacheServer,port={0},type=Member,member={1}

Notification Type | Notification Source | Message
--- | --- | ---
gemfire.distributedsystem.cacheserver.client.joined | CacheServer MBean Name | Client joined with Id <Client ID>
gemfire.distributedsystem.cacheserver.client.left | CacheServer MBean Name | Client crashed with Id <Client ID>
gemfire.distributedsystem.cacheserver.client.crashed | CacheServer MBean Name | Client left with Id <Client ID>

Since:
  GemFire 7.0

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `closeAllContinuousQuery(String regionName)`
  Deprecated.
  This method is dangerous because it only modifies the target cache server - other copies of the CQ on other servers are not affected.
  `void`
  `closeContinuousQuery(String queryName)`
  Deprecated.
  This method is dangerous because it only modifies the target cache server - other copies of the CQ on other servers are not affected.
  `void`
  `executeContinuousQuery(String queryName)`
  Deprecated.
  This method is dangerous because it only modifies the target cache server - other copies of the CQ on other servers are not affected.
  `ServerLoadData`
  `fetchLoadProbe()`
  Returns the load probe for this CacheServer.
  `long`
  `getActiveCQCount()`
  Returns the number of active (currently executing) CQs.
  `String`
  `getBindAddress()`
  Returns a string representing the IP address or host name that this CacheServer will listen on.
  `int`
  `getCapacity()`
  Returns the capacity (in megabytes) of the client queue.
  `int`
  `getClientConnectionCount()`
  Returns the number of sockets accepted and used for client to server messaging.
  `String[]`
  `getClientIds()`
  Returns a list of IDs for all connected clients.
  `long`
  `getClientNotificationAvgLatency()`
  Returns the average latency for processing client notifications.
  `float`
  `getClientNotificationRate()`
  Returns the rate of client notifications.
  `double`
  `getConnectionLoad()`
  Returns the load from client to server connections as reported by the load probe installed in this server.
  `int`
  `getConnectionThreads()`
  Returns the current number of threads handling a client connection.
  `String[]`
  `getContinuousQueryList()`
  Returns a list of names for all registered CQs.
  `int`
  `getCurrentClients()`
  Returns the number of client virtual machines connected.
  `String`
  `getDiskStoreName()`
  Returns the name of the disk store that is used for persistence.
  `String`
  `getEvictionPolicy()`
  Returns the eviction policy that is executed when the capacity of the client queue is reached.
  `long`
  `getGetRequestAvgLatency()`
  Returns the average get request latency.
  `float`
  `getGetRequestRate()`
  Returns the rate of get requests.
  `String`
  `getHostNameForClients()`
  Returns the name or IP address to pass to the client as the location where the server is listening.
  `int`
  `getIndexCount()`
  Returns the total number of indexes in use by the member.
  `String[]`
  `getIndexList()`
  Returns a list of names for all indexes.
  `double`
  `getLoadPerConnection()`
  Returns the estimate of how much load is added for each new connection as reported by the load probe installed in this server.
  `double`
  `getLoadPerQueue()`
  Returns the estimate of how much load is added for each new queue as reported by the load probe installed in this server.
  `long`
  `getLoadPollInterval()`
  Returns the frequency (in milliseconds) to poll the load probe on this CacheServer.
  `int`
  `getMaxConnections()`
  Returns the maximum allowed client connections.
  `int`
  `getMaximumMessageCount()`
  Returns the maximum number of messages that can be enqueued in a client-queue.
  `int`
  `getMaximumTimeBetweenPings()`
  Returns the maximum amount of time between client pings.
  `int`
  `getMaxThreads()`
  Returns the maximum number of threads allowed in this CacheServer to service client requests.
  `int`
  `getMessageTimeToLive()`
  Returns the time (in seconds) after which a message in the client queue will expire.
  `int`
  `getNumClientNotificationRequests()`
  Returns the number of cache client notification requests.
  `int`
  `getNumSubscriptions()`
  Returns the number of clients who have existing subscriptions.
  `int`
  `getPort()`
  Returns the port on which this CacheServer listens for clients.
  `long`
  `getPutRequestAvgLatency()`
  Returns the average put request latency.
  `float`
  `getPutRequestRate()`
  Returns the rate of put requests.
  `float`
  `getQueryRequestRate()`
  Returns the rate of queries.
  `double`
  `getQueueLoad()`
  Returns the load from queues as reported by the load probe installed in this server.
  `long`
  `getRegisteredCQCount()`
  Returns the number of registered CQs.
  `int`
  `getSocketBufferSize()`
  Returns the configured buffer size of the socket connection for this CacheServer.
  `int`
  `getThreadQueueSize()`
  Returns the current number of connections waiting for a thread to start processing their message.
  `int`
  `getTotalConnectionsTimedOut()`
  Returns the total number of client connections that timed out and were closed.
  `int`
  `getTotalFailedConnectionAttempts()`
  Returns the total number of client connection requests that failed.
  `long`
  `getTotalIndexMaintenanceTime()`
  Returns the total time spent updating indexes due to changes in the data.
  `long`
  `getTotalReceivedBytes()`
  Returns the total number of bytes received from clients.
  `long`
  `getTotalSentBytes()`
  Returns the total number of bytes sent to clients.
  `boolean`
  `isRunning()`
  Returns whether or not this CacheServer is running.
  `void`
  `removeIndex(String indexName)`
  Remove an index.
  `ClientHealthStatus[]`
  `showAllClientStats()`
  Returns health and statistic information for all clients.
  `ClientQueueDetail[]`
  `showClientQueueDetails()`
  Shows a list of client with their queue statistics.
  `ClientQueueDetail`
  `showClientQueueDetails(String clientId)`
  Shows queue statistics of the given client.
  `ClientHealthStatus`
  `showClientStats(String clientId)`
  Returns health and statistic information for the give client id.
  `void`
  `stopContinuousQuery(String queryName)`
  Deprecated.
  This method is dangerous because it only modifies the target cache server - other copies of the CQ on other servers are not affected.

- ## Method Details

  - ### getPort

    int getPort()
    Returns the port on which this CacheServer listens for clients.
    Returns:
      the port on which this CacheServer listens for clients

  - ### getBindAddress

    String getBindAddress()
    Returns a string representing the IP address or host name that this CacheServer will listen on.
    Returns:
      a string representing the IP address or host name that this CacheServer will listen on

  - ### getSocketBufferSize

    int getSocketBufferSize()
    Returns the configured buffer size of the socket connection for this CacheServer.
    Returns:
      the configured buffer size of the socket connection for this CacheServer

  - ### getMaximumTimeBetweenPings

    int getMaximumTimeBetweenPings()
    Returns the maximum amount of time between client pings. This value is used to determine the health of client's attached to the server.
    Returns:
      the maximum amount of time between client pings

  - ### getMaxConnections

    int getMaxConnections()
    Returns the maximum allowed client connections.
    Returns:
      the maximum allowed client connections

  - ### getMaxThreads

    int getMaxThreads()
    Returns the maximum number of threads allowed in this CacheServer to service client requests.
    Returns:
      the maximum number of threads allowed in this CacheServer to service client requests

  - ### getMaximumMessageCount

    int getMaximumMessageCount()
    Returns the maximum number of messages that can be enqueued in a client-queue.
    Returns:
      the maximum number of messages that can be enqueued in a client-queue

  - ### getMessageTimeToLive

    int getMessageTimeToLive()
    Returns the time (in seconds) after which a message in the client queue will expire.
    Returns:
      the time (in seconds) after which a message in the client queue will expire

  - ### getLoadPollInterval

    long getLoadPollInterval()
    Returns the frequency (in milliseconds) to poll the load probe on this CacheServer.
    Returns:
      the frequency (in milliseconds) to poll the load probe on this CacheServer

  - ### getHostNameForClients

    String getHostNameForClients()
    Returns the name or IP address to pass to the client as the location where the server is listening. When the server connects to the locator it tells the locator the host and port where it is listening for client connections. If the host the server uses by default is one that the client can’t translate into an IP address, the client will have no route to the server’s host and won’t be able to find the server. For this situation, you must supply the server’s alternate hostname for the locator to pass to the client.
    Returns:
      the name or IP address to pass to the client as the location where the server is listening

  - ### fetchLoadProbe

    ServerLoadData fetchLoadProbe()
    Returns the load probe for this CacheServer.
    Returns:
      the load probe for this CacheServer

  - ### isRunning

    boolean isRunning()
    Returns whether or not this CacheServer is running.
    Returns:
      True of the server is running, false otherwise.

  - ### getCapacity

    int getCapacity()
    Returns the capacity (in megabytes) of the client queue.
    Returns:
      the capacity (in megabytes) of the client queue

  - ### getEvictionPolicy

    String getEvictionPolicy()
    Returns the eviction policy that is executed when the capacity of the client queue is reached.
    Returns:
      the eviction policy that is executed when the capacity of the client queue is reached

  - ### getDiskStoreName

    String getDiskStoreName()
    Returns the name of the disk store that is used for persistence.
    Returns:
      the name of the disk store that is used for persistence

  - ### getClientConnectionCount

    int getClientConnectionCount()
    Returns the number of sockets accepted and used for client to server messaging.
    Returns:
      the number of sockets accepted and used for client to server messaging

  - ### getCurrentClients

    int getCurrentClients()
    Returns the number of client virtual machines connected.
    Returns:
      the number of client virtual machines connected

  - ### getGetRequestAvgLatency

    long getGetRequestAvgLatency()
    Returns the average get request latency.
    Returns:
      the average get request latency

  - ### getPutRequestAvgLatency

    long getPutRequestAvgLatency()
    Returns the average put request latency.
    Returns:
      the average put request latency

  - ### getTotalConnectionsTimedOut

    int getTotalConnectionsTimedOut()
    Returns the total number of client connections that timed out and were closed.
    Returns:
      the total number of client connections that timed out and were closed

  - ### getTotalFailedConnectionAttempts

    int getTotalFailedConnectionAttempts()
    Returns the total number of client connection requests that failed.
    Returns:
      the total number of client connection requests that failed

  - ### getThreadQueueSize

    int getThreadQueueSize()
    Returns the current number of connections waiting for a thread to start processing their message.
    Returns:
      the current number of connections waiting for a thread to start processing their message

  - ### getConnectionThreads

    int getConnectionThreads()
    Returns the current number of threads handling a client connection.
    Returns:
      the current number of threads handling a client connection

  - ### getConnectionLoad

    double getConnectionLoad()
    Returns the load from client to server connections as reported by the load probe installed in this server.
    Returns:
      the load from client to server connections as reported by the load probe installed in this server

  - ### getLoadPerConnection

    double getLoadPerConnection()
    Returns the estimate of how much load is added for each new connection as reported by the load probe installed in this server.
    Returns:
      the estimate of how much load is added for each new connection as reported by the load probe installed in this server

  - ### getQueueLoad

    double getQueueLoad()
    Returns the load from queues as reported by the load probe installed in this server.
    Returns:
      the load from queues as reported by the load probe installed in this server

  - ### getLoadPerQueue

    double getLoadPerQueue()
    Returns the estimate of how much load is added for each new queue as reported by the load probe installed in this server.
    Returns:
      the estimate of how much load is added for each new queue as reported by the load probe installed in this server

  - ### getGetRequestRate

    float getGetRequestRate()
    Returns the rate of get requests.
    Returns:
      the rate of get requests

  - ### getPutRequestRate

    float getPutRequestRate()
    Returns the rate of put requests.
    Returns:
      the rate of put requests

  - ### getTotalSentBytes

    long getTotalSentBytes()
    Returns the total number of bytes sent to clients.
    Returns:
      the total number of bytes sent to clients

  - ### getTotalReceivedBytes

    long getTotalReceivedBytes()
    Returns the total number of bytes received from clients.
    Returns:
      the total number of bytes received from clients

  - ### getNumClientNotificationRequests

    int getNumClientNotificationRequests()
    Returns the number of cache client notification requests.
    Returns:
      the number of cache client notification requests

  - ### getClientNotificationAvgLatency

    long getClientNotificationAvgLatency()
    Returns the average latency for processing client notifications.
    Returns:
      the average latency for processing client notifications

  - ### getClientNotificationRate

    float getClientNotificationRate()
    Returns the rate of client notifications.
    Returns:
      the rate of client notifications

  - ### getRegisteredCQCount

    long getRegisteredCQCount()
    Returns the number of registered CQs.
    Returns:
      the number of registered CQs

  - ### getActiveCQCount

    long getActiveCQCount()
    Returns the number of active (currently executing) CQs.
    Returns:
      the number of active (currently executing) CQs

  - ### getQueryRequestRate

    float getQueryRequestRate()
    Returns the rate of queries.
    Returns:
      the rate of queries

  - ### getIndexCount

    int getIndexCount()
    Returns the total number of indexes in use by the member.
    Returns:
      the total number of indexes in use by the member

  - ### getIndexList

    String[] getIndexList()
    Returns a list of names for all indexes.
    Returns:
      an array of names for all indexes

  - ### getTotalIndexMaintenanceTime

    long getTotalIndexMaintenanceTime()
    Returns the total time spent updating indexes due to changes in the data.
    Returns:
      the total time spent updating indexes due to changes in the data

  - ### removeIndex

    void removeIndex(String indexName) throws Exception
    Remove an index.
    Parameters:
      `indexName` - Name of the index to be removed.
    Throws:
      `Exception` - if an exception is encountered when removing the index

  - ### getContinuousQueryList

    String[] getContinuousQueryList()
    Returns a list of names for all registered CQs.
    Returns:
      an array of names for all registered CQs

  - ### executeContinuousQuery

    @Deprecated void executeContinuousQuery(String queryName) throws Exception
    Deprecated.
    This method is dangerous because it only modifies the target cache server - other copies of the CQ on other servers are not affected. Using the client side CQ methods to modify a CQ.
    Execute an ad-hoc CQ on the server
    Parameters:
      `queryName` - Name of the CQ to execute.
    Throws:
      `Exception` - if an exception is encountered while executing the CQ

  - ### stopContinuousQuery

    @Deprecated void stopContinuousQuery(String queryName) throws Exception
    Deprecated.
    This method is dangerous because it only modifies the target cache server - other copies of the CQ on other servers are not affected. Using the client side CQ methods to modify a CQ.
    Stop (pause) a CQ from executing
    Parameters:
      `queryName` - Name of the CQ to stop.
    Throws:
      `Exception` - if an exception is encountered while stopping the CQ

  - ### closeAllContinuousQuery

    @Deprecated void closeAllContinuousQuery(String regionName) throws Exception
    Deprecated.
    This method is dangerous because it only modifies the target cache server - other copies of the CQ on other servers are not affected. Using the client side CQ methods to modify a CQ.
    Unregister all CQs from a region
    Parameters:
      `regionName` - Name of the region from which to remove CQs.
    Throws:
      `Exception` - if an exception is encountered while unregistering the CQs

  - ### closeContinuousQuery

    @Deprecated void closeContinuousQuery(String queryName) throws Exception
    Deprecated.
    This method is dangerous because it only modifies the target cache server - other copies of the CQ on other servers are not affected. Using the client side CQ methods to modify a CQ.
    Unregister a CQ
    Parameters:
      `queryName` - Name of the CQ to unregister.
    Throws:
      `Exception` - if an exception is encountered while unregistering the CQ

  - ### getClientIds

    String[] getClientIds() throws Exception
    Returns a list of IDs for all connected clients.
    Returns:
      A list of IDs or a length 0 array if no clients are registered.
    Throws:
      `Exception` - if an exception is encountered while retrieving the IDs

  - ### showClientStats

    ClientHealthStatus showClientStats(String clientId) throws Exception
    Returns health and statistic information for the give client id. Some of the information (CPUs, NumOfCacheListenerCalls, NumOfGets,NumOfMisses, NumOfPuts,NumOfThreads, ProcessCpuTime) only available for clients which have set a "StatisticsInterval".
    Parameters:
      `clientId` - ID of the client for which to retrieve information.
    Returns:
      health and statistic information for the given client
    Throws:
      `Exception` - if an exception is encountered while retrieving the statistics

  - ### getNumSubscriptions

    int getNumSubscriptions()
    Returns the number of clients who have existing subscriptions.
    Returns:
      the number of clients who have existing subscriptions

  - ### showAllClientStats

    ClientHealthStatus[] showAllClientStats() throws Exception
    Returns health and statistic information for all clients. Some of the information (CPUs, NumOfCacheListenerCalls, NumOfGets,NumOfMisses, NumOfPuts,NumOfThreads, ProcessCpuTime) only available for clients which have set a "StatisticsInterval".
    Returns:
      health and statistic information for all clients
    Throws:
      `Exception` - if an exception is encountered while retrieving the statistics

  - ### showClientQueueDetails

    ClientQueueDetail[] showClientQueueDetails() throws Exception
    Shows a list of client with their queue statistics. Client queue statistics shown in this method are the following eventsEnqueued,eventsRemoved , eventsConflated ,markerEventsConflated , eventsExpired, eventsRemovedByQrm , eventsTaken , numVoidRemovals
    Returns:
      an array of ClientQueueDetail
    Throws:
      `Exception` - if an exception is encountered while retrieving the statistics

  - ### showClientQueueDetails

    ClientQueueDetail showClientQueueDetails(String clientId) throws Exception
    Shows queue statistics of the given client. Client queue statistics shown in this method are the following eventsEnqueued,eventsRemoved , eventsConflated ,markerEventsConflated , eventsExpired, eventsRemovedByQrm , eventsTaken , numVoidRemovals
    Parameters:
      `clientId` - the ID of client which is returned by the attribute ClientIds
    Returns:
      client queue statistics for the given client
    Throws:
      `Exception` - if an exception is encountered while retrieving the statistics